#include "config.h"
#include <windows.h>
#include <cstring>
#include <cstdio>
#include <commctrl.h>
#include <algorithm>
#include "text.h"
#include "ghostmap.h"
#include "surface.h"


namespace{

HINSTANCE hDllInstance;                                    // DLL̃CX^Xnh
const char* iniPath;                                       // init@C̃tpX
char* ghostFileBuf;                                        // ghost.txt̃pXpobt@
char newGhostFile[GHOST_SETTING_BUFSIZE];                  // ghost.txt̃pXύXꂽꍇ̐VpX
const int scalePercentDigit = 4;                           // TCY̔{̍ő包+1(\0p)
char scalePercent[scalePercentDigit];                      // TCY̔{w
GhostMap* ghostMap;                                        // S[Xg̃nbV}bv
const DWORD testWindowStyle = WS_POPUPWINDOW | WS_CAPTION; // \eXgpEChẼX^C
const DWORD testWindowStyleEx = WS_EX_TOOLWINDOW;          // \eXgpEChE̊gX^C

}


// ghost.txt̃pXw肷_CAO\AnewGhostFileɃpXi[
// ɃI[iEBhEw
bool GetGhostSetting(HWND hWnd){
  // t@CI[vp\̂̐ݒ
  OPENFILENAME ofn;
  memset(&ofn, 0, sizeof(OPENFILENAME));    // 
  ofn.lStructSize = sizeof(OPENFILENAME);   // \̂̃TCY
  
  // _CAÕtB^ݒAghost.txt݂̂܂͑SẴt@C\
  ofn.lpstrFilter = "Ghost Definition File(ghost.txt)\0ghost.txt\0All Files(*.*)\0*.*\0\0";
  
  ofn.nFilterIndex = 1;                     // ftHgłghost.txt̂ݕ\
  ofn.lpstrFile    = newGhostFile;          // newGhostFileɃtpXi[
  ofn.nMaxFile     = GHOST_SETTING_BUFSIZE; // newGhostFilẽobt@TCY
  ofn.lpstrTitle   = "t@CJ";      // _CAÕ^Cg
  ofn.lpstrDefExt  = "txt";                 // gq͂Ȃꍇ̃ftHggq
  ofn.hwndOwner    = hWnd;                  // _CAOLEBhE
  
  // _CAO̐ݒ
  ofn.Flags = OFN_FILEMUSTEXIST |           // ݂t@Ĉ݋
              OFN_HIDEREADONLY;             // Read Only`FbN{bNX\
  
  if(!GetOpenFileName(&ofn)){                       // LZ܂̓G[
    if(CommDlgExtendedError() != 0){
      Message("Error : Can't Open \"ghost.txt\"."); // G[̏ꍇx
    }
    return false;
  }
  else return true;
}


// A\0̈ʒu+1Ԃ
// dest͏\ȃobt@mۂĂKv
char* AddString(char* dest, const char* src1, const char* src2){
  strcpy(dest, src1);
  strcat(dest, src2);
  return dest + strlen(dest) + 1;
}



// ݒ_CAȌI
void Finish(HWND hWnd){
  if(GetDlgItemText(hWnd, GHOST_SETTING_PATH, newGhostFile, GHOST_SETTING_BUFSIZE) == 0)
    newGhostFile[0] = '\0';                                // ghost.txt̃pXȂ當ɂ
  if(GetDlgItemText(hWnd, SVG_SCALING_PERCENT, scalePercent, scalePercentDigit) == 0)
    scalePercent[0] = '\0';                                // {͗Ȃ當ɂ
  
  // init@C݂ȂȂ쐬
  HANDLE hIniFile = CreateFile(iniPath, GENERIC_WRITE, 0, NULL,
                               OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
  CloseHandle(hIniFile);
  
  Surface::SetScale(scalePercent);                                               // {ݒ
  
  // init@Cɏ
  const char* const iniString[][2] = {                                           // init@C̃L[Ƃ̒l
    {"GhostFile=",         newGhostFile},                                        // ghost.txẗʒu
    {"Scaling=",           (Surface::GetScalingMode()) ? ("1") : ("0")},         // TCYLǂ
    {"Scale=",             scalePercent},                                        // TCY̔{
    {"SurfaceNumberView=", (Surface::GetSurfaceNumViewMode()) ? ("1") : ("0")},  // T[tBXԍ\Lǂ
    {"DODOME_Mode=",       (ghostMap->GetMode()) ? ("1") : ("0")}                // DODOME ModeLǂ
  };
  int dataNum = sizeof(iniString)/sizeof(iniString[0]);                 // init@Cɏލڂ̐
  int iniStrLen = 1;                                                    // init@Cɏޕ̒
  for(int i=0; i<dataNum; ++i){                                         // \0̕Ƃďl1Ƃ
    iniStrLen += strlen(iniString[i][0]) + strlen(iniString[i][1]) + 1; // L[ƒl̕+\0
  }
  char* str = new char[iniStrLen];                                      // init@Cɏޕ̃obt@
  char* next = str;                                                     // ɕʒu(O̍ڂ\0̎)
  for(int i=0; i<dataNum; ++i){
    next = AddString(next, iniString[i][0], iniString[i][1]);           // L[ƒl𕶎ɉ
  }
  *next = '\0';                                                         // 2ڂ\0
  if(WritePrivateProfileSection("SVG", str, iniPath) == 0)
    Message("Error : Can't Write SVGD.ini");                            // ߂Ȃꍇx
  if(strcmp(ghostFileBuf, newGhostFile) != 0){                          // S[Xgݒt@CύXꂽꍇ
    strcpy(ghostFileBuf, newGhostFile);
    ghostMap->ReadGhostFile(newGhostFile);                              // ghost.txtǂݍ
  }
  delete[] str;
  
}



LRESULT CALLBACK PrevTestProc(HWND hTestWnd, UINT msg, WPARAM wp, LPARAM lp);

// \eXgpEChENX̓o^
void RegistPrevTest(const char* className){
  WNDCLASS wndClass;
  wndClass.style = 0;                                            // EChẼX^C
  wndClass.lpfnWndProc = PrevTestProc;                           // EChEvV[W
  wndClass.cbClsExtra = 0;                                       // NX\̂̒ǉ̈(gp)
  wndClass.cbWndExtra = 0;                                       // EBhE\̂̒ǉ̈(gp)
  wndClass.hInstance = hDllInstance;                             // DLL̃CX^Xnh
  wndClass.hIcon = 0;                                            // ACR̃rbg}bv(gp)
  wndClass.hCursor = LoadCursor(0, IDC_ARROW);                   // J[\(Ŵ̂gp)
  wndClass.hbrBackground = (HBRUSH)GetStockObject(DKGRAY_BRUSH); // wiDFœhԂ
  wndClass.lpszMenuName = 0;                                     // NXj[w(gp)
  wndClass.lpszClassName = className;                            // EChENX̖O
  RegisterClass(&wndClass);                                      // NXo^łȂȂ牽Ȃ
}



void InitDialog(HWND hWnd, HWND& hUpDown, HWND& hScalingPercent, int& scalingVal, const char* className){
  RegistPrevTest(className);                               // \eXgpEChENX̓o^
  hUpDown = GetDlgItem(hWnd, SVG_SCALING_UPDOWN);          // TCY̔{wpAbv_ERg[
  hScalingPercent = GetDlgItem(hWnd, SVG_SCALING_PERCENT); // TCY̔{wpGfBbgRg[
  scalingVal = atoi(scalePercent);                         // TCY̔{
  UDACCEL ua[2] = {{0, 5}, {1, 5}};                        // Abv_ERg[̕ω
  SendMessage(hUpDown, UDM_SETACCEL, 2, (LPARAM)ua);       // Abv_ERg[̕ωʂ̏ݒ
  SendMessage(hUpDown, UDM_SETBUDDY, (WPARAM)GetDlgItem(hWnd, SVG_SCALING_PERCENT), 0); // Rg[̊֘At
  SendMessage(hUpDown, UDM_SETRANGE, 0, (LPARAM)MAKELONG(SCALE_UPPER_LIMIT, SCALE_LOWER_LIMIT)); // {͈̔
  SendMessage(hUpDown, UDM_SETPOS, 0, (LPARAM)MAKELONG((short)scalingVal, 0));          // {̏l
  SetDlgItemText(hWnd, GHOST_SETTING_PATH, ghostFileBuf);                               // ghost.txt̃pX\
  CheckDlgButton(hWnd, SVG_SCALING, (Surface::GetScalingMode()) ? (1) : (0));           // `FbN{bNX
  CheckDlgButton(hWnd, SVG_SURFACE_NUMBER, (Surface::GetSurfaceNumViewMode()) ? (1) : (0));
  CheckDlgButton(hWnd, DODOME_MODE, (ghostMap->GetMode()) ? (1) : (0));
}


// \eXgpEChẼTCY擾
void GetPrevWindowSize(int& width, int& height){
  RECT rect;                                                            // NCAg̈̃TCYwp
  rect.left = 0;
  rect.top = 0;
  rect.right = std::max(Surface::GetWidth()+10, SURFACE_WIDTH);         // XvCg̃TCYɍ킹()
  rect.bottom = std::max(Surface::GetHeight()+10, SURFACE_HEIGHT);      // ㉺EɃ}[WŒ5
  AdjustWindowRectEx(&rect, testWindowStyle, FALSE, testWindowStyleEx); // EChẼTCY𓾂
  
  width = rect.right-rect.left;                                         // EChE̕
  height = rect.bottom-rect.top;                                        // EChE̍
}



LRESULT CALLBACK PrevTestProc(HWND hTestWnd, UINT msg, WPARAM wp, LPARAM lp){
  HDC hDC;
  BITMAPINFO bmInfo;  // \p̃rbg}bv̏
  HBITMAP hBitmap;    // \p
  HBITMAP hBitmapOld; // ȑÕIuWFNg
  HDC hDCBmp;         // XvCgۑpDC
  PAINTSTRUCT ps;
  RECT rect;          // NCAg̈擾p
  switch(msg){
    case WM_CREATE :
      return 0;
    case WM_DESTROY :
      PostQuitMessage(0);
      return 0;
    case WM_PAINT :
      InitializeBITMAPINFO(bmInfo, Surface::GetWidth(), Surface::GetHeight(), 24); // rbg}bv̏wb_
      hDC = BeginPaint(hTestWnd, &ps);
      hDCBmp = CreateCompatibleDC(hDC);
      hBitmap = CreateDIBitmap(hDC, &bmInfo.bmiHeader, 0, 0, 0, 0); // DIB쐬
      hBitmapOld = (HBITMAP)SelectObject(hDCBmp, hBitmap);          // ȑÕIuWFNgۑ
      
      ghostMap->GetDefaultImage(hBitmap);                           // \s[0]DIBƂĎ擾
      
      GetClientRect(hTestWnd, &rect);
      // DCʒɓ]
      BitBlt(hDC, (rect.right - bmInfo.bmiHeader.biWidth)/2, (rect.bottom - bmInfo.bmiHeader.biHeight)/2,
             bmInfo.bmiHeader.biWidth, bmInfo.bmiHeader.biHeight, hDCBmp, 0, 0, SRCCOPY);
      
      EndPaint(hTestWnd, &ps);
      SelectObject(hDCBmp, hBitmapOld);                             // ȑÕIuWFNgɖ߂
      DeleteDC(hDCBmp);
      DeleteObject(hBitmap);
    return 0;
  }
  return DefWindowProc(hTestWnd, msg, wp, lp);
}



// \eXg
void PreviewTest(HWND hWnd, HWND& hTestWnd, const char* className){
  if(hTestWnd) DestroyWindow(hTestWnd);                    // ɃEChE݂Ȃčĕ`
  int height, width;
  GetPrevWindowSize(width, height);
  RECT parentRect;
  GetWindowRect(hWnd, &parentRect);                        // ݒEChẼNCAg̈
  int posX = parentRect.left-width-5;                      // ݒEChE̍ɔzu
  int posY = parentRect.bottom-height;                     // ݒEChẺ[ɂ
  
  // \eXgpEChE쐬
  hTestWnd = CreateWindowEx(testWindowStyleEx, className, "", testWindowStyle,
                            posX, posY, width, height, hWnd, 0, hDllInstance, 0);
  if(hTestWnd == 0){
    Message("Error : Can't create window.");
    return;
  }
  
  ShowWindow(hTestWnd, SW_SHOW);                           // EChEԂɂ
  UpdateWindow(hTestWnd);
  MSG msg;
  while(GetMessage(&msg, 0, 0, 0)){
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
}



// \eXg̃EChEXV
void ReloadPrevTest(HWND hTestWnd){
  if(!hTestWnd) return;
  int height, width;
  GetPrevWindowSize(width, height);                      // EChẼTCYvZ
  RECT rect;
  GetWindowRect(hTestWnd, &rect);
  int posX = rect.right-width;                           // E[̈ʒuςȂ
  int posY = rect.bottom-height;                         // [̈ʒuςȂ
  InvalidateRect(hTestWnd, 0, TRUE);                     // TCYύXȂꍇłIɍĕ`(wi܂)
  MoveWindow(hTestWnd, posX, posY, width, height, TRUE); // \eXg̍XV
}



// ݒ_CAÕR[obN֐
BOOL CALLBACK SettingDialog(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp){
  const char* const className = "PreviewTest";                     // \eXgpEChENX
  static HWND hUpDown;                                             // TCY̔{wpAbv_ERg[
  static HWND hScalingPercent;                                     // TCY̔{wpGfBbgRg[
  static HWND hTestWnd = 0;                                        // \eXgpEChE
  static int scalingVal;                                           // TCY̔{
  switch(msg){
    case WM_INITDIALOG :                                           // 
      InitDialog(hWnd, hUpDown, hScalingPercent, scalingVal, className);
      return TRUE;
    case WM_CLOSE :                                                // {^ꂽꍇ
      if(hTestWnd) DestroyWindow(hTestWnd);
      UnregisterClass(className, hDllInstance);                    // EChEꂽo^
      Finish(hWnd);                                                // I
      EndDialog(hWnd, 0);
      return TRUE;
    case WM_COMMAND :
      switch(LOWORD(wp)){
        case GHOST_SETTING_REF_BUTTON :                            // ghost.txt̎Q
          if(GetGhostSetting(hWnd))
            SetDlgItemText(hWnd, GHOST_SETTING_PATH, newGhostFile);
          return TRUE;
        case SVG_SCALING :                                         // TCY
          Surface::SetScalingMode(!IsDlgButtonChecked(hWnd, SVG_SCALING));
          CheckDlgButton(hWnd, SVG_SCALING, (Surface::GetScalingMode()) ? (1) : (0));
          ReloadPrevTest(hTestWnd);
          return TRUE;                                             // `FbN{bNX̏ԂύX
        case SVG_SURFACE_NUMBER :
          Surface::SetSurfaceNumViewMode(!IsDlgButtonChecked(hWnd, SVG_SURFACE_NUMBER));
          CheckDlgButton(hWnd, SVG_SURFACE_NUMBER, (Surface::GetSurfaceNumViewMode()) ? (1) : (0));
          ReloadPrevTest(hTestWnd);
          return TRUE;
        case DODOME_MODE :
          ghostMap->SetMode(!IsDlgButtonChecked(hWnd, DODOME_MODE));
          CheckDlgButton(hWnd, DODOME_MODE, (ghostMap->GetMode()) ? (1) : (0));
          return TRUE;
        case DODOME_JAMA :
          Message("ӂӂӁccB");
          return TRUE;
        case PREVIEW_TEST :
          PreviewTest(hWnd, hTestWnd, className);
          return TRUE;
        case CONFIGURE_OK :                                        // OK{^ꂽꍇ
          if(hTestWnd) DestroyWindow(hTestWnd);
          UnregisterClass(className, hDllInstance);                // \eXgpEChE̓o^
          Finish(hWnd);                                            // I
          EndDialog(hWnd, 0);
          return TRUE;
      }
      if(lp == (LPARAM)hScalingPercent && HIWORD(wp) == EN_CHANGE){
        if(GetDlgItemText(hWnd, SVG_SCALING_PERCENT, scalePercent, scalePercentDigit) == 0)
          scalePercent[0] = '\0';                                // {͗Ȃ當ɂ
        Surface::SetScale(scalePercent);
        ReloadPrevTest(hTestWnd);
        return TRUE;
      }
      return FALSE;
  }
  return FALSE;
}



// ݒ_CAO쐬
void Setting(HINSTANCE hInstance, const char* valIniPath, char* ghostFile, GhostMap* valGhostMap){
  // O[oϐ
  iniPath = valIniPath;
  ghostMap = valGhostMap;
  ghostFileBuf = ghostFile;
  newGhostFile[0] = '\0';   // ̕ŏ
  hDllInstance = hInstance;
  DialogBox(hInstance, "CONFIGURE", 0, (DLGPROC)SettingDialog);
}


// 01Ŏw肳ꂽݒ荀ڂǂݎ
// ȕ̏ꍇfalseԂ
bool GetBoolSetting(const char* str){
  if(!str || str[0] == '\0') return false;                     // 񂪋
  else if((str[0] == '0' || str[0] == '1') && str[1] == '\0'){ // "0""1"
    if(str[0] == '0') return false;
    else return true;
  }
  else return false;                                           // "0""1"ȊO
}



// {̏ݒ
void InitScale(const char* scaling, const char* scale){
  Surface::SetScalingMode(GetBoolSetting(scaling));          // TCY̗Lw
  unsigned int valScale = Surface::SetScale(scale);          // {
  snprintf(scalePercent, scalePercentDigit, "%u", valScale); // ۂɎw肵{ŕ
}


// DODOME Modȅݒ
void InitMode(GhostMap* ghostMap, const char* mode){
  ghostMap->SetMode(GetBoolSetting(mode));
}



// T[tBXԍ\̗L̐ݒ
void InitSurfaceNumViewMode(const char* surfaceNumViewMode){
  Surface::SetSurfaceNumViewMode(GetBoolSetting(surfaceNumViewMode));
}



// init@CL[̒l擾
// K蓮delete邱
char* GetIniString(const char* key, const char* iniPath){
  char str[GHOST_SETTING_BUFSIZE];
  // init@CASVGZNṼL["Scale"̒liTCY̔{jǂݍ
  if(GetPrivateProfileString("SVG", key, "\0", str, GHOST_SETTING_BUFSIZE, iniPath)
       == GHOST_SETTING_BUFSIZE-1){
     return 0;
  }
  else return NewString(str);
}



