#ifndef GHOSTINFO_H
#define GHOSTINFO_H

#include "hashmap.h"
#include "surface.h"


typedef hash_map<int, int> SurfaceMap;


class GhostInfo{
  Surface surface;
  SurfaceMap surfaceMap;              // T[tBXԍƃXvCgԍ̑ΉtpnbV}bv
  int prevSpriteID;                   // OɎw肵ĂXvCgID  +ŃT[tBXw肷ۂɗp
                                      // OɃT[tBXw肪ꍇA+10ƂȂ悤-1ŏ
public:
  
  GhostInfo() : prevSpriteID(-1){}
  
  // T[tBX摜t@C̃pXݒ
  void SetSurfaceFile (const char* path){ surface.SetSurfaceFile(path); }
  
  // T[tBX摜t@C̃pX
  const char* GetSurfaceFile() const{ return surface.GetSurfaceFile(); }
  
  void AddSurface(const char* surface, const char* sprite);
  void AddSurface(int surfaceID, const char* sprite);
  void AddSurface(int surfaceID, int spriteID){
    prevSpriteID = spriteID;          // *ł̎wpɒÕubNŎw肵ĂXvCgIDۑ
    surfaceMap[surfaceID] = spriteID; // IDǉAɑ݂ꍇ㏑
  }
  
  int WriteImage(int surfaceID, HBITMAP hBitmap) const;
};




#endif // GHOSTINFO_H
