#include "ghostmap.h"
#include "text.h"
#include <process.h>

namespace{

const char ghostDefDelim = ','; // S[Xg`t@C̋؂蕶isj

}

// delimŎw肳ꂽ؂蕶ƂāAtxt̐擪玟̃g[N̈ʒuT
char* NextToken(const char* txt, char delim){
  char* delimPos = strchr(txt, delim);
  return (delimPos) ? (delimPos+1) : (0); // ؂蕶炻̎̈̕ʒuԂ
}



// txt̐擪玟̍s̈ʒuT
inline char* NextLine(const char* txt){
  return NextToken(txt, '\n');
}



// ̐擪̋󔒕ǂݔ΂
// 󔒕݂̂łĂȂ0Ԃ
char* SkipSpace(char* str){
  if(!str || *str == '\0') return 0;
  while(isspace(*str)){            // 󔒂ǂݔ΂
    if(*(++str) == '\0') return 0; // 󔒂݂̂ŏIĂ
  }
  return str;
}

inline const char* SkipSpace(const char* str){
  return SkipSpace(const_cast<char*>(str));
}

// ̃_uNI[e[VăRs[
// K蓮delete邱
// sꍇ0Ԃ
char* CutDoubleQuotation(const char* str){
  if(!str) return 0;                        // |C^nullwĂ
  
  const char* left = strchr(str, '\"');     // "̈ʒu
  if(!left) return NewString(str);          // "Ȃ炻̂܂܃Rs[
  const char* right = strchr(left+1, '\"'); // E"̈ʒu
  if(!right) return 0;                      // ȂȂ玸sƂ݂Ȃ
  
  const char* check = str;
  while(check != left){
    if(!isspace(*(check++))) return 0;      // ̐擪獶"܂ł̊Ԃɋ󔒕ȊOΎs
  }
  check = right+1;
  while(*check != '\0'){
    if(!isspace(*(check++))) return 0;      // E"當̖܂ł̊Ԃɋ󔒕ȊOΎs
  }
  
  char* ret = new char[right - left];
  strncpy(ret, left+1, right-left-1);       // "ň͂܂ꂽRs[
  ret[right-left-1] = '\0';                 // \0ǉ
  return ret;
}



// S[Xg̃nbV}bvɂ
void GhostMap::ClearGhostInfo(){
  Surface::ClearCache();
  for(GhostHashMap::iterator i=ghostMap.begin(); i!=ghostMap.end();){
    //Fhash_mapiterator̓L[deleteɑ삷
    //    삵Ȃ̂ŃCNgɍsȂ
    delete i->second;
    delete (i++)->first;
  }
  ghostMap.clear();
}



// `t@CǂݍݗpXbh̃nh
void GhostMap::CloseThreadHandle(){
  if(hThread != 0){
    WaitForSingleObject(hThread, INFINITE); // XbhsȂÎ҂
    CloseHandle(hThread);
    hThread = 0;
  }
}



/*
  S[Xg`t@C̕񂩂
  w肳ꂽGg̃f[^(=)܂ňړ
  Gg݂Ȃf[^ꍇ0Ԃ
*/
char* CutGhostDefInfo(char* str, const char* entry){
  if(!entry || *entry == '\0') return 0;           // ΏۂƂGg
  str = SkipSpace(str);                            // 擪̋󔒂ǂݔ΂
  if(!str) return 0;                               // 󔒂݂̂ŏIĂ
  
  if(strncmp(str, entry, strlen(entry)) == 0){     // ̐擪Ggɍv
    char* equal = SkipSpace(str+strlen(entry));    // Gg̒
    if(*equal != '=') return 0;                    // Gg̎=
    return (*(equal+1) != '\0') ? (equal+1) : (0); // f[^̏ꍇ0ԂAłȂȂf[^Ԃ
  }
  else return 0;                                   // GgɈvȂ
}



enum{
  GHOST_DEF_SUCCESS,
  GHOST_DEF_FAILED,
  GHOST_DEF_EOF
};


// S[Xg`t@CT[tBXw蕔ǂݍ
int ReadSurfaceNum(char* token, char* idSeparator, GhostInfo* ghostInfo){
  // :̍Eǂ炩ĂꍇG[
  if(token == idSeparator || *(idSeparator+1) == '\0') return GHOST_DEF_FAILED;
  *idSeparator = '\0';                         // :̕\0ɒu
  ghostInfo->AddSurface(token, idSeparator+1); // T[tBX`ǉ
  return GHOST_DEF_SUCCESS;
}



bool IsEOF(const char* token){
  token = SkipSpace(token);                   // 󔒂͓ǂݔ΂
  if(!token) return false;                    // 󔒂݂̂ŏIĂ
  int eofStrLen = strlen("/EOF");
  if(strncmp(token, "/EOF", eofStrLen) == 0){ // g[N̐擪/EOFɈv
    if(*(token+eofStrLen) == '\0' || isspace(*(token+eofStrLen))){
      return true;                            // /EOFȂtrue
    }
  }
  return false;
}



// S[Xg`t@Cg[Nǂݍ
// sakuraNameɂ͏lƂ0Ă
int ReadGhostDefToken(char* token, GhostInfo* ghostInfo, char*& sakuraName, const char* ghostDefPath){
  char* equalPos = strchr(token, '=');
  if(!equalPos){                                                     // =Ȃsurface/EOF̉\l
    char* idSeparator = strchr(token, ':');                          // :ȂsurfacewƂ
    if(idSeparator) return ReadSurfaceNum(token, idSeparator, ghostInfo);
    else{
      if(IsEOF(token)) return GHOST_DEF_EOF;
      else return GHOST_DEF_SUCCESS;
    }
  }
  else{
    char* entryDataStart;
    if(entryDataStart = CutGhostDefInfo(token, "sakura")){           // sakura=
      delete[] sakuraName;                                           // łɓo^ς݂̏ꍇ폜ď
      sakuraName = CutDoubleQuotation(entryDataStart);               // \0̖Oo^
    }
    
    else if(entryDataStart = CutGhostDefInfo(token, "surfacefile")){ // surfacefile=
      // S[Xg`t@C̃tpXƃT[tBXt@C̃pXtpX쐬
      AutoString surfacePath(CutDoubleQuotation(entryDataStart));
      if(surfacePath.str != 0){                                      // T[tBXt@C̃pX擾
        AutoString surfaceFullPath(ChangeFileNameOfFullPath(ghostDefPath, surfacePath.str));
        ghostInfo->SetSurfaceFile(surfaceFullPath.str);              // T[tBXt@C̃tpXo^
      }
      else return GHOST_DEF_FAILED;
    }
    else if(entryDataStart = CutGhostDefInfo(token, "surface")){     // surface=
      char* idSeparator = strchr(entryDataStart, ':');               // :̈ʒuTēo^
      if(idSeparator) return ReadSurfaceNum(entryDataStart, idSeparator, ghostInfo);
    }
  }
  return GHOST_DEF_SUCCESS;
}



// S[Xg`t@Csǂݍ
int ReadGhostDefLine(char* txtLine, GhostInfo* ghostInfo, char*& sakuraName, const char* ghostDefPath){
  char* token = txtLine;                               // s̐擪ǂݍ
  char* nextToken = NextToken(token, ghostDefDelim);   // ݓǂݍłg[N̎̃g[N
  while(token){
    if(nextToken) *(nextToken-1) = '\0';               // ؂蕶̈ʒuŕ𕪊
    int tokenRet = ReadGhostDefToken(token, ghostInfo, sakuraName, ghostDefPath);
    if(tokenRet != GHOST_DEF_SUCCESS) return tokenRet; // g[Nǂݍ݁As܂/EOFȂI
    token = nextToken;                                 // ̃g[Nɐi
    if(nextToken) nextToken = NextToken(token, ghostDefDelim);
  }
  return GHOST_DEF_SUCCESS;
}



// S[Xg`t@C߂nbV}bvɓo^
void SetGhostInfo(GhostHashMap& ghostMap, const char* ghostDefPath){
  bool error_IllegalData = false;                              // G[L^pϐ
  
  Text ghostDefText(ghostDefPath);                             // S[Xg`t@Cǂݍ
  if(!ghostDefText.txt){                                       // t@Cǂݍ߂Ȃ
    CombinedMessage("Error : Can't read file : ", ghostDefPath);
    return;
  }
  if(strncmp(ghostDefText.txt, "SVG3", strlen("SVG3")) != 0){  // S[Xg`t@CSVG3Ŏn܂Ȃ
    CombinedMessage("Error : Ghost definition file is not SVG3 : ", ghostDefPath);
    return;
  }
  
  // F̓̕ϐ͂̂܂܃nbV}bṽL[ƃf[^ɂȂ邽߁AnbV}bṽfXgN^delete
  GhostInfo* ghostInfo  = new GhostInfo;
  char* sakuraName      = 0;
  
  char* head = NextLine(ghostDefText.txt);                     // sڂǂݍ
  char* nextLine = NextLine(head);                             // ݓǂݍłs̎̍s
  while(head){
    if(nextLine) *(nextLine-1) = '\0';                         // sŕ؂
    if(*head != '/'){                                          // Rgs͖AłȂȂsƂɓǂݍ
      int lineRet = ReadGhostDefLine(head, ghostInfo, sakuraName, ghostDefPath);
      if(lineRet == GHOST_DEF_FAILED) error_IllegalData = true;
      if(lineRet != GHOST_DEF_SUCCESS) break;                  // s܂/EOF
    }
    else if(strncmp(head, "/EOF", strlen("/EOF")) == 0) break; // s/EOFȂI
    head = nextLine;                                           // ̍sɐi
    if(nextLine) nextLine = NextLine(nextLine);
    //else CombinedMessage("Warning : Can't find /EOF : ", ghostDefPath); // xo鐔̂ō̏gp
  }
  
  if(!sakuraName || !ghostInfo->GetSurfaceFile() || error_IllegalData){
    CombinedMessage("Error : Illegal data : ", ghostDefPath);  // KvȍڂĂ
    delete ghostInfo;
    delete sakuraName;
  }
  else{ // S[Xg̏nbV}bvɒǉ
    GhostHashMap::iterator ghostItr = ghostMap.find(sakuraName);
    if(ghostItr != ghostMap.end()){                            // dĂꍇU폜Ăēxǉ
      char* oldName = ghostItr->first;
      GhostInfo* oldInfo = ghostItr->second;
      ghostMap.erase(ghostItr);                                // nbV}bv폜
      delete oldName;
      delete oldInfo;
    }
    ghostMap[sakuraName] = ghostInfo;
  }
}


// S[Xgݒt@Csǂݍ
bool ReadGhostFileLine(GhostHashMap& ghostMap, char* txtLine, char* ghostDir){
  if(strncmp(txtLine, "GHOST,", strlen("GHOST,")) == 0){ // s̐擪GHOST
    char* ghostDefPathPos = txtLine;                     // S[Xg`t@C̃pẌʒu
    ghostDefPathPos = NextToken(ghostDefPathPos, ',');   // SVG̐̕܂ňړ
    if(!ghostDefPathPos) return false;                   // ,ꍇ̓G[
    
    ghostDefPathPos = NextToken(ghostDefPathPos, ',');   // SSTP-Viewerł̐ݒ蕶񕔕܂ňړ
    if(!ghostDefPathPos) return false;                   // ,ꍇ̓G[
    
    ghostDefPathPos = NextToken(ghostDefPathPos, ',');   // SVG`t@C̑΃pXLq܂ňړ
    if(!ghostDefPathPos) return false;                   // ,ꍇ̓G[
    
    // ghost.txt̃tpX"S[Xg`t@C̃pXtpX쐬
    AutoString ghostDefPath(CutDoubleQuotation(ghostDefPathPos));
    if(!ghostDefPath.str) return false;
    AutoString ghostDefFullPath(Combine(ghostDir, ghostDefPath.str));
    if(!ghostDefFullPath.str) return false;
    
    SetGhostInfo(ghostMap, ghostDefFullPath.str);        // nbV}bvɓo^
  }
  return true;
}



// Xbhɓnf[^ ghostFileɕi[IwiIɊJj
struct ReadGhostFileThreadData{
  char* pGhostFile;
  GhostMap* pGhostMap;
  
  ReadGhostFileThreadData(char* varGhostFile, GhostMap* varGhostMap)
    : pGhostFile(varGhostFile), pGhostMap(varGhostMap){}
  
  ~ReadGhostFileThreadData(){ delete[] pGhostFile; }
};



// S[Xgݒt@CǂݍݗpXbh̖{
unsigned __stdcall ReadGhostFileThread(LPVOID param){
  char* ghostFile = ((ReadGhostFileThreadData*)param)->pGhostFile;
  GhostMap* ghostMap = ((ReadGhostFileThreadData*)param)->pGhostMap;
  bool error_IllegalData = false;                                  // G[L^pϐ
  
  ghostMap->ClearGhostInfo();                                      // ݂̃f[^폜
  
  if(ghostFile == 0 || *ghostFile == '\0'){
    Message("Warning : \"ghost.txt\" is not specified.");          // pX
    return 1;
  }
  
  Text ghostFileText(ghostFile);                                   // S[Xg`t@Cǂݍ
  if(!ghostFileText.txt){                                          // t@Cǂݍ߂Ȃ
    CombinedMessage("Error : Can't read file : ", ghostFile);      // ghost.txtJȂ
    return 1;
  }
  
  char* head = ghostFileText.txt;
  char* nextLine = NextLine(head);                                 // ݓǂݍłs̎̍s
  AutoString ghostDir(NewString(ghostFile));                       // ghost.txt̃fBNg
  *(strrchr(ghostDir.str, '\\')+1) = '\0';                         // Ō\Ő؂
  while(head){
    if(nextLine) *(nextLine-1) = '\0';                             // sŕ؂
    if(!ReadGhostFileLine(ghostMap->ghostMap, head, ghostDir.str))
      error_IllegalData = true;                                    // sǂݍ݁AG[L^
    head = nextLine;                                               // ̍sɐi
    if(nextLine) nextLine = NextLine(nextLine);
  }
  
  
  // G[ꍇx
  if(error_IllegalData) Message("Error : Illegal data : ghost.txt");
  delete (ReadGhostFileThreadData*)param;      // newp[^ւ̃|C^nĂ̂ō폜
  return 0;
}


void GhostMap::ReadGhostFile(const char* ghostFilePath){
  unsigned int threadID;
  CloseThreadHandle();                      // XbhI҂ČÂXbhnhJ
                                            // (XbhdN͋֎~)
  // ghost.txẗʒuthis|C^Xbhɓn߃Rs[
  // 쐬ꂽXbhdeleteKv
  ReadGhostFileThreadData* data = new ReadGhostFileThreadData(NewString(ghostFilePath), this);
  
  // Xbh쐬уXbhnh̍XV
  hThread = (HANDLE)_beginthreadex(0, 0, ReadGhostFileThread, (LPVOID)data, 0, &threadID);
  if(hThread == 0){
    Message("Error : Can't create thread"); // ɃXbh쐬łȂȂx
  }
}


// rbg}bvɉ摜`
int GhostMap::GetImage(char* ghostName, int surfaceID, HBITMAP hBitmap){
  if(surfaceID < 0) return 1;                                       // ʏ}CiX̒l͎gȂ
                                                                    // (-1̔\͂炭NCAgŏ)
  GhostHashMap::const_iterator ghostInfo = (!mode) ? Find(ghostName) : Find("ǂǂ߂ɂイ");
  // ݂ȂS[Xg̏ꍇ1Ԃ łȂȂ摜`
  int ret = (ghostInfo != ghostMap.end()) ? (ghostInfo->second->WriteImage(surfaceID, hBitmap)) : (1);
  return ret;
}


// \eXgp
int GhostMap::GetDefaultImage(HBITMAP hBitmap){
  GhostHashMap::const_iterator ghostInfo = Find("ǂǂ߂ɂイ");
  if(ghostInfo == ghostMap.end()){                                  // ǂǂ߂ɂイo^
    if(ghostMap.empty()){
      Message("Warning : ghost.txt is not loaded.");                // nbV}bvȂx
      return 1;
    }
    else ghostInfo = ghostMap.begin();                              // nbV}bvłȂꍇŏ̗vfQ
  }
  return ghostInfo->second->WriteImage(0, hBitmap);
}



