#ifndef GHOSTMAP_H
#define GHOSTMAP_H



#include "hashmap.h"
#include "ghostinfo.h"
#include <windows.h>


// hash_mappr֐IuWFNg
struct StringEqualTo : std::binary_function<const char*, const char*, bool>{
  bool operator()(const char* x, const char* y) const{
    return strcmp(x, y) == 0;
  }
};

typedef hash_map<char*, GhostInfo*, hash<char*>, StringEqualTo> GhostHashMap;


class GhostMap{
  GhostHashMap     ghostMap;                     // nbV}bv{
  HANDLE           hThread;                      // nbV}bv\zpXbh̃nh
                                                 // Xbh͈̂݋N
  bool             mode;                         // DODOME Mode
  
  void ClearGhostInfo();                         // nbV}bvɂ
  void CloseThreadHandle();                      // `t@CǂݍݗpXbh̃nh
  
  // S[Xgݒt@CǂݍݗpXbh̖{
  // _beginthreadexɃoϐnȂ߃th֐this(+S[Xgݒt@C̃pX)nđp
  friend unsigned __stdcall ReadGhostFileThread(LPVOID param);
  
  // nbV}bvS[Xg̏o
  GhostHashMap::iterator Find(char* ghostName){
    if(hThread != 0) WaitForSingleObject(hThread, INFINITE); // nbV}bv쐬Ȃҋ@
    return ghostMap.find(ghostName);
  }
  
public:
  GhostMap() : hThread(0), mode(false){}
  
  ~GhostMap(){
    CloseThreadHandle();                         // s̃XbhȂҋ@
    ClearGhostInfo();                            // nbV}bṽJ
  }
  
  void ReadGhostFile(const char* ghostFileName); // ghost.txtǂݍ
  
  // rbg}bvɉ摜`
  int GetImage(char* ghostName, int surfaceID, HBITMAP hBitmap);
  int GetDefaultImage(HBITMAP hBitmap);          // \eXgp
  
  // DODOME Mode
  bool GetMode(){ return mode; }
  void SetMode(bool valMode){ mode = valMode; }
};



#endif // GHOSTMAP_H

