
#include "surface.h"
#include <cstring>

namespace{

const unsigned int PNG_SIG_SIZE = 8;        // PNGVOl`̃oCg
const unsigned int PNG_COLOR_BYTECOUNT = 4; // PNG1sNZ̃oCg
// rbg}bṽobt@TCY
const int BMP_BUFSIZE = SURFACE_WIDTH*SURFACE_HEIGHT*PNG_COLOR_BYTECOUNT;
const int MIN_FONT_SIZE = 9;

}

SurfaceCache Surface::cache; // ÓIoɎԂ
const Surface* Surface::prevSurface = 0;

int Surface::scaledWidth = 48;
int Surface::scaledHeight = 64;
bool Surface::surfaceNumViewMode = false;
bool Surface::useScaling = false;
int Surface::fontSize = 12;


void InitializeBITMAPINFO(BITMAPINFO& bitmapInfo, int width, int height, unsigned short bitCount){
  BITMAPINFOHEADER bitmapInfoHeader;
  bitmapInfoHeader.biSize          = sizeof(BITMAPINFOHEADER); // \̂̃TCY
  bitmapInfoHeader.biWidth         = width;                    // rbg}bv̕
  bitmapInfoHeader.biHeight        = height;                   // rbg}bv̍
  bitmapInfoHeader.biPlanes        = 1;                        // ^[QbgfoCX̖ʂ̐(ʏ1)
  bitmapInfoHeader.biBitCount      = bitCount;                 // 1sNZ̃rbg
  bitmapInfoHeader.biCompression   = BI_RGB;                   // k`(񈳏k)
  bitmapInfoHeader.biSizeImage     = 0;                        // 摜TCY(BI_RGB̏ꍇ0ł܂Ȃ)
  bitmapInfoHeader.biXPelsPerMeter = 0;                        // ^[QbgfoCX̐̉𑜓x(gp)
  bitmapInfoHeader.biYPelsPerMeter = 0;                        // ^[QbgfoCX̐̉𑜓x(gp)
  bitmapInfoHeader.biClrUsed       = 0;                        // J[e[ũCfbNX̐(gp)
  bitmapInfoHeader.biClrImportant  = 0;                        // \ɕKvȐFCfbNX̐(gp)
  bitmapInfo.bmiHeader = bitmapInfoHeader;
}



// ̂ƂBITMAPINFOύX悤ȉӏ͖̂łŏ
SurfaceCache::SurfaceCache() : fp(0), image(0), bottom(-1){
  InitializeBITMAPINFO(bitmapInfo, SURFACE_WIDTH, SURFACE_HEIGHT, PNG_COLOR_BYTECOUNT*8); // rbg}bv̏
}


void SurfaceCache::Clear(){
  if(image){                                     // f[^cĂ
    // png_read_end͉摜̍Ō܂œǂ܂ȂƎgȂ͗l
    // 炭IDATȍ~̃`N̓ǂݏoCRC`FbN݂̂Ȃ̂ŕK{ł͂ȂƎv
    png_destroy_read_struct(&pPng, &pngInfo, 0); // libpngŊmۂJ
    for(int i=0; i<height; ++i){                 // 摜f[^i[񎟌zj
      delete[] image[i];
    }
    delete[] image;
    image = 0;
  }
  bottom = -1;                                   // ɓǂݍ񂾃XvCĝƂ
  if(fp) fclose(fp);                             // png_structsvɂȂOɕĂ͂Ȃ
  fp = 0;
}



// tJ[C[Wɕϊ
void ConvertToFullColor(png_structp pPng, png_infop pngInfo, int bitDepth, int colorType){
                                                       // pbg摜RGB֕ϊ
  if(colorType == PNG_COLOR_TYPE_PALETTE)              png_set_palette_to_rgb(pPng);
                                                       colorType = PNG_COLOR_TYPE_RGB;
                                                       // 8rbg菭ȂO[XP[摜8rbg֕ϊ
  if(colorType == PNG_COLOR_TYPE_GRAY && bitDepth < 8) png_set_gray_1_2_4_to_8(pPng);
                                                       // tRNS̓ߏ񂪂ƂtAt@`l֕ϊ
  if(png_get_valid(pPng, pngInfo, PNG_INFO_tRNS))      png_set_tRNS_to_alpha(pPng);
                                                       // 16 rbg/`l8rbg/`l֕ϊ
  if(bitDepth == 16)                                   png_set_strip_16(pPng);
                                                       // 1,2,4̐[x̃pbNEsNZ1sNZ/oCgɊg
  if(bitDepth < 8)                                     png_set_packing(pPng);
  if(colorType == PNG_COLOR_TYPE_RGB ||                // BGȐœǂݍ
     colorType == PNG_COLOR_TYPE_RGB_ALPHA)            png_set_bgr(pPng);
  if(colorType == PNG_COLOR_TYPE_GRAY ||               // O[XP[摜RGBɕϊ
     colorType == PNG_COLOR_TYPE_GRAY_ALPHA)           png_set_gray_to_rgb(pPng);
  if(colorType == PNG_COLOR_TYPE_RGB ||                // At@`lIɉ
     colorType == PNG_COLOR_TYPE_GRAY)                 png_set_add_alpha(pPng, 0xFF, PNG_FILLER_AFTER);
}



// PNG̉摜f[^ǂݍޏ
bool SurfaceCache::ReadPngInfo(){
  // \̏
  pPng = png_create_read_struct(PNG_LIBPNG_VER_STRING, 0, 0, 0);
  if(!pPng) return false;                                 // png_struct\̂łȂ
  pngInfo = png_create_info_struct(pPng);
  if(!pngInfo){                                           // png_info\̂łȂ
    png_destroy_read_struct(&pPng, 0, 0);
    return false;
  }
  
  png_init_io(pPng, fp);                                  // t@C|C^Zbg
  png_set_sig_bytes(pPng, PNG_SIG_SIZE);                  // VOl`mFς݂Ȃ̂œǂݔ΂
  int bitDepth;                                           // 摜̃`lЂƂ̃rbg[x
  int colorType;                                          // LȃJ[/At@`l̕\
  png_uint_32 pngHeight, pngWidth;                        // 摜̍Ɖ
  int interlace;                                          // C^[X̃^Cv
  png_read_info(pPng, pngInfo);                           // Ǎ
  png_get_IHDR(pPng, pngInfo, &pngWidth, &pngHeight, &bitDepth, &colorType, &interlace, 0, 0);
  
  ConvertToFullColor(pPng, pngInfo, bitDepth, colorType); // tJ[C[Wɕϊ
  
  int pass;
  if(interlace == PNG_INTERLACE_NONE) pass = 1;
  else if(interlace == PNG_INTERLACE_ADAM7){
    pass = png_set_interlace_handling(pPng);              // C^[Xݒ
  }
  else{
    png_destroy_read_struct(&pPng, 0, 0);
    return false;
  }
  // ϊݒ肵Alibpngɓ͕ϊݒKp邽png_info\̂XV
  png_read_update_info(pPng, pngInfo);
  
  height = pngHeight;
  width = pngWidth;
  
  image = new BYTE*[pngHeight];                           // 摜f[^i[񎟌z쐬
  for(unsigned int i=0; i<pngHeight; ++i){
    image[i] = new BYTE[pngWidth*PNG_COLOR_BYTECOUNT];
  }
  
  // C^[XPNG̏ꍇApng_read_rowsœǂݍ߂ԂɂĂ
  if(interlace == PNG_INTERLACE_ADAM7){
    // passǂݍނƉ摜̂ōŌ1񕪂cēǂݍ
    for(int i=0; i<pass-1; ++i) png_read_rows(pPng, image, 0, pngHeight);
  }
  
  return true;
}



bool SurfaceCache::ReadInfo(const char* surfaceFile){
  Clear();                                           // ÂLbV͍폜Ă
  fp = fopen(surfaceFile, "rb");
  if(!fp) return false;                              // t@CJȂ
  char pngSig[PNG_SIG_SIZE];
  size_t block = fread(pngSig, 1, PNG_SIG_SIZE, fp); // VOl`Ǎ
  if(block == PNG_SIG_SIZE){                         // ǂݍ񂾃oCgVOl`̃oCgɈv
    // PNGVOl`ł邩`FbN
    if(png_sig_cmp((png_byte*)pngSig, (png_size_t)0, PNG_SIG_SIZE) == 0){
      if(ReadPngInfo() && height%SURFACE_HEIGHT == 0 && width%SURFACE_WIDTH == 0)
        return true;                                 // ɓǂݍ܂ꂽ
    }
  }
  
  // PNGȊȌꍇA܂͉摜ɓǂݍ߂Ȃ
  Clear();
  return false;
}



bool SurfaceCache::ReadPngPixel(int valBottom){
  if(bottom < valBottom){                             // ܂ǂݍłȂXvCg
    if(valBottom >= height) return false;             // 摜͈̔͂𒴂Ă
    // w肳ꂽXvCĝs܂œǂݏo
    png_read_rows(pPng, &(image[bottom+1]), 0, valBottom-bottom);
    bottom = valBottom;
  }
  return true;
}



bool SurfaceCache::WriteBuffer(BYTE* bmpBuffer, int spriteID){
  // XvCg[A[yщ[̉摜ł̈ʒu
  int left = (spriteID * SURFACE_WIDTH) % width;
  int top  = ((spriteID * SURFACE_WIDTH) / width) * SURFACE_HEIGHT;
  int valBottom = top + SURFACE_HEIGHT - 1;
  
  if(!ReadPngPixel(valBottom)) return false; // 摜̓ǂݏo
  
  for(int i=top; i<=valBottom; ++i){         // 摜̐؂o
    memcpy(bmpBuffer+(valBottom-i)*SURFACE_WIDTH*PNG_COLOR_BYTECOUNT,
           image[i]+left*PNG_COLOR_BYTECOUNT, SURFACE_WIDTH*PNG_COLOR_BYTECOUNT);
  }
  
  return true;
}



// XvCg̍ɃT[tBXԍ\
void WriteSurfaceNum(HDC hDC, int surfaceID, int fontSize){
  char numString[11];                                             // \镶
  snprintf(numString, sizeof(numString), "%d", surfaceID);
  SIZE size;
  
  HFONT hFont = CreateFont(fontSize, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, DEFAULT_CHARSET,
                           OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 0, 0);
  if(!hFont){                                                     // tHg쐬Ɏsꍇ
    Message("Error : Can't write surface number.");
    return;
  }
  SelectObject(hDC, hFont);
  if(!GetTextExtentPoint32(hDC, numString, sizeof(numString), &size)){ // \̃TCY擾
    Message("Error : Can't write surface number.");
    return;
  }
  int posX = 0;                                                   // \ʒu()
  int posY = Surface::GetHeight() - size.cy;
  
  TextOut(hDC, posX, posY, numString, strlen(numString));         // T[tBXԍ`
  SelectObject(hDC, GetStockObject(SYSTEM_FONT));
  DeleteObject(hFont);
}



// XvCg` 0As1Ԃ
int Surface::WriteImage(int surfaceID, int spriteID, HBITMAP hBitmap) const{
  if(spriteID < 0) return 1;                                // \܂͖`
  
  // DIB1C̃TCY4̔{ɂKv邪A
  //T[tBX̉(48)4̔{ɂȂĂ̂BMP_BUFSIZE͏4̔{ɂȂ
  BYTE bmpBuffer[BMP_BUFSIZE];                              // XvCgۑpobt@
  
  if(prevSurface != this){                                  // LbVɎcĂT[tBXƈႤ
    if(cache.ReadInfo(surfaceFile.str)) prevSurface = this; // LbVɐꍇ
    else{
      prevSurface = 0;
      return 1;
    }
  }
  // Kvȕ܂œǂݍł邩`FbNbmpBufferɏ
  if(!cache.WriteBuffer(bmpBuffer, spriteID)) return 1;
  
  // TCYύXĂꍇ̓T[tBXԍ\@\Lȏꍇ
  if(useScaling || surfaceNumViewMode){
    HDC hMemDC = CreateCompatibleDC(0);                             // fBXvCƌ݊ƂDC
    BITMAPINFO bmInfo;                                              // DIBZNVp
    InitializeBITMAPINFO(bmInfo, GetWidth(), GetHeight(), PNG_COLOR_BYTECOUNT*8);
    BYTE* pixelBits;                                                // DIBZNṼsNZrbg
    HBITMAP hBitmapTmp = CreateDIBSection(0, &bmInfo, DIB_RGB_COLORS, (void**)&pixelBits, 0, 0);
    HBITMAP hBitmapOld = (HBITMAP)SelectObject(hMemDC, hBitmapTmp); // DCDIBZNVɊ֘At
    SetStretchBltMode(hMemDC, HALFTONE);                            // Lk[hύX
    // rbg}bṽTCYύXăDCɕ`
    StretchDIBits(hMemDC, 0, 0, GetWidth(), GetHeight(), 0, 0, SURFACE_WIDTH, SURFACE_HEIGHT,
                  bmpBuffer, cache.GetBITMAPINFO(), DIB_RGB_COLORS, SRCCOPY);
    
    if(surfaceNumViewMode) WriteSurfaceNum(hMemDC, surfaceID, fontSize); // T[tBXԍ\LȂ烁DCɏ
    
    int ret = 0;
    // rbg}bvnhɕ`
    if(SetDIBits(0, hBitmap, 0, GetHeight(), pixelBits, &bmInfo, DIB_RGB_COLORS) == 0){
      ret = 1;                                                      // sꍇ
    }
    SelectObject(hMemDC, hBitmapOld);
    DeleteDC(hMemDC);
    DeleteObject(hBitmapTmp);
    return ret;
  }
  else{
    // rbg}bvnhɕ`
    if(SetDIBits(0, hBitmap, 0, SURFACE_HEIGHT, bmpBuffer, cache.GetBITMAPINFO(), DIB_RGB_COLORS) == 0){
      return 1;                                                     // sꍇ
    }
  }
  return 0;
}



// TCY̔{𕶎Ŏw
unsigned int Surface::SetScale(const char* percent){
  unsigned int valPercent;                                                  // TCY̔{
  if(!percent || *percent == '\0') valPercent = 100;
  else{
    char* endPtr;
    valPercent = strtoul(percent, &endPtr, 10);
    if(*endPtr != '\0') valPercent = 100;                                   // ȕꍇ{100%Ƃ
    else if(valPercent < SCALE_LOWER_LIMIT) valPercent = SCALE_LOWER_LIMIT; // {𒴂Ă
    else if(valPercent > SCALE_UPPER_LIMIT) valPercent = SCALE_UPPER_LIMIT; // {𒴂Ă
  }
  
  const double scale = (double)valPercent/100.0;
  scaledWidth = (int)((double)SURFACE_WIDTH*scale);                         // ƍݒ
  scaledHeight = (int)((double)SURFACE_HEIGHT*scale);
  fontSize = scaledHeight/4;                                                // tHgTCY͉摜1/4̍Ƃ
  if(fontSize < MIN_FONT_SIZE) fontSize = MIN_FONT_SIZE;                    // ꍇ͒
  
  return valPercent;
}


