///////////////////////////////////////////////////////////////////////////
//  _R   _l__                                                        //
//     __ >     _    SSTP Bottle Surface Preview Plug-In  for "SVG"   //
//       _ i L`i               SVG.dll Unofficial Version            //
//         >     ܁R                                                    //
//        /        _      " SVG Surface Loader  DODOME Edition "      //
//       /      /    __                                                //
//           m       R_       Coded by  DODOME & RAINBOW            //
//      /    /                                                           //
//     /   /|                                                            //
//   i  /AR                                                           //
//    |  | R _                                                         //
//    | /    _ l                 Have a Good Bottle Time!             //
//    | |      j/                                                       //
//   m  j   '                                                        //
//  (Q^                                                                //
///////////////////////////////////////////////////////////////////////////

#include "svgd_core.h"
#include "surface.h"
#include "ghostmap.h"
#include "config.h"


namespace{

const char* iniFile = "SVGD.ini"; // init@C
char*       iniPath;              // inĩtpX
char*       ghostFile;            // Ghost.txt̃tpX
GhostMap*   ghostMap;             // S[Xg̃nbV}bv
HINSTANCE   hInstance;            // DLL̃CX^Xnh


}

/*
  idlpj
  procedure Load(Path: PChar); cdecl;
  
  DLL̓ǂݍݎɌĂяo܂BPathɂ́ADLL݂̑ꏊn܂B
  DLLŗL̐ݒt@CȂǂۑꍇPathŎw肳fBNg𗘗pĂB
*/
void __cdecl Load(LPSTR path){
  ghostMap = new GhostMap;
  iniPath = Combine(path, iniFile);                               // init@C̃tpXݒ
  
  // init@CASVGZNṼL[̒lǂݍ
  AutoString scaling(GetIniString("Scaling", iniPath));
  AutoString scale(GetIniString("Scale", iniPath));
  AutoString mode(GetIniString("DODOME_Mode", iniPath));
  AutoString surfaceNumViewMode(GetIniString("SurfaceNumberView", iniPath));
  ghostFile = GetIniString("GhostFile", iniPath);
  
  InitScale(scaling.str, scale.str);                              // TCY̗LƔ{
  
  if(!mode.str) Message("Error : Illegal string : svgd.ini");     // ɓǂ߂ĂȂꍇx
  else InitMode(ghostMap, mode.str);                              // DODOME Mode
  
  if(!surfaceNumViewMode.str) Message("Error : Illegal String : svgd.ini");
  else InitSurfaceNumViewMode(surfaceNumViewMode.str);
  
  if(!ghostFile) Message("Error : Too long path : svgd.ini");     // ɓǂ߂ĂȂꍇx
  else ghostMap->ReadGhostFile(ghostFile);                        // ghost.txtǂݍ
}



/*
  idlpj
  procedure Unload; cdecl;
  
  DLL̉OɌĂяo܂B
  Ăяoɂė~͂܂̂ŁA
  DLLƎɎ擾\[X̉ȂǂsĂB
*/
void __cdecl Unload(){
  delete[] iniPath;
  delete ghostMap;
  delete[] ghostFile;
}



/*
  idlpj
  function GetVersion(Name: PChar; NameLen: integer;
                      var Version: integer; var CanConfigure: boolean): integer; cdecl;
  
  vOC̃o[WvOC񍐂܂B
  NameLenoCgȓŁANameɃvOC̖OԂĂB
  ̒̕ɁAł΃vOĈ̃o[WԍȂǂ܂߂Ƃ悢łB
  Version͑ΉĂAPĨo[WԍłB1ԂĂB
  CanConviguréAConfigureł邩ǂԂ܂B
  falseԂꍇłAConfigure֐͉Ȃ֐ƂăGLX|[g͂ĂB
*/
int __cdecl GetPluginVersion(LPSTR name, int nameLen, int* version, SVGD_Bool* canConfigure){
  LPCSTR THIS_DLL = "SVG Surface Loader DODOME Edition Ver. 1.2.3";
  
  *version      = 1; // version͏1Ԃ
  *canConfigure = 1; // Configure
  
  // nameLenoCgȓŃvOC̖OnameɊi[
  strncpy(name, THIS_DLL, nameLen);
  name[nameLen-1] = '\0';
  
  return strlen(THIS_DLL) + 1;
}



/*
  idlpj
  function GetImageSize(Ghost: PChar; Surface: integer; var w, h: integer): integer; cdecl;
  
  ۂ̃C[WԂ̂ɐ旧āAC[W̃TCY擾܂B
  ֐́AC[WTCY̎擾Ɏsꍇ1Aꍇ0ԂĂB
  Ghost, Surface͂ꂼAKvȃS[XgƃT[tBXԍłB
  whɁA摜̕ƍĊ֐IĂB
  
  ̊֐́Aۂɉ摜ǂݍŐmȃTCY擾Kv͕K܂B
  ܂AGetImageSizeꍇłA
  ۂ GetImage̒iKŊ֐s(摜Ȃ)邱Ƃɖ͂܂B
  DLLŒ肳ꂽTCỶ摜ԂȂdlȂA
  ̊֐͖ⓚpŒ萔Ԃ̎ɂđvłB
  
  ۂɉ摜ǂݍŐmȃTCYԂꍇ́A
  GetImageĂ΂邱ƂlāA
  ǂݍ񂾉摜ێĂKv邩܂B
*/
int __cdecl GetImageSize(LPSTR ghostName, int surfaceID, int* w, int* h){
  *w = Surface::GetWidth();
  *h = Surface::GetHeight();
  return 0;
}



/*
  idlpj
  function GetImage(Ghost: PChar; Surface: integer; H: HBITMAP): integer; cdecl;
  
  ۂɃC[W擾܂B
  H̓rbg}bvnhŁA֐̌ĂяoŊɍ쐬ATCYw肳Ă܂B
  ̃rbg}bvɁA߂摜`悵ĂB
  ֐sꍇ(w摜Ȃꍇ)1Aꍇ0Ԃ܂B
*/
int __cdecl GetImage(LPSTR ghostName, int surfaceID, HBITMAP hBitmap){
  return ghostMap->GetImage(ghostName, surfaceID, hBitmap);
}



/*
  idlpj
  procedure Configure; cdecl;
  
  DLL̐ݒs܂B
  {gNCAgݒʂŃvOCڂ_uNbNꍇɌĂяo܂B
  Oŏݒ_CAOJāA̐ݒ茋ʂt@CɕۑȂǂĂB
*/
void __cdecl Configure(){
  Setting(hInstance, iniPath, ghostFile, ghostMap);
}



#ifdef __cplusplus
extern "C" {
#endif

BOOL WINAPI DllMain(HINSTANCE hInstDLL, DWORD fdwReason, LPVOID lpvReserved){
  switch(fdwReason){
    case DLL_PROCESS_ATTACH :
      hInstance = hInstDLL;
      break;
  }
  return TRUE;
}

#ifdef __cplusplus
}
#endif


